---
title: CSS Shapes
slug: Web/CSS/CSS_Shapes
tags:
  - Boundaries
  - CSS
  - CSS Shapes
  - Guide
  - Overview
  - Reference
  - Shape
  - wrapping
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary"><strong>CSS Shapes</strong> describe geometric shapes for use in CSS. For the <a href="https://drafts.csswg.org/css-shapes/">Level 1 specification</a>, CSS Shapes can be applied to floating elements.</span> The specification defines a number of different ways to define a shape on a floated element, causing wrapping lines to wrap round the shape rather than following the rectangle of the element's box.</p>

<h2 id="Basic_Example">Basic example</h2>

<p>The example below shows an image that has been floated left, and the <code>shape-outside</code> property applied with a value of <code>circle(50%)</code>. This creates a circle shape, and the content wrapping the float now wraps around that shape. This changes the length of the wrapping text's line boxes.</p>

<p>{{EmbedGHLiveSample("css-examples/shapes/overview/circle.html", '100%', 720)}}</p>

<h2 id="Reference">Reference</h2>

<h3 id="Properties">Properties</h3>

<div class="index">
<ul>
 <li>{{cssxref("shape-image-threshold")}}</li>
 <li>{{cssxref("shape-margin")}}</li>
 <li>{{cssxref("shape-outside")}}</li>
</ul>
</div>

<h3 id="Data_types">Data types</h3>

<div class="index">
<ul>
 <li>{{cssxref("&lt;basic-shape&gt;")}}</li>
</ul>
</div>

<h2 id="Guides">Guides</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Shapes/Overview_of_CSS_Shapes">Overview of CSS Shapes</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Shapes/Shapes_From_Box_Values">Shapes from Box Values</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes">Basic Shapes</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Shapes/Shapes_From_Images">Shapes from Images</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Edit_CSS_shapes">Edit Shape Paths in CSS — Firefox Developer Tools</a></li>
</ul>

<h2 id="External_Resources">External Resources</h2>

<ul>
 <li><a href="https://codepen.io/KristopherVanSant/post/css-shapes-resources">A list of CSS Shapes resources</a></li>
 <li><a href="https://alistapart.com/article/css-shapes-101">CSS Shapes 101</a></li>
 <li><a href="https://www.sarasoueidan.com/blog/css-shapes/">Creating non-rectangular layouts with CSS Shapes</a></li>
 <li><a href="https://webdesign.tutsplus.com/tutorials/how-to-use-css-shapes-in-your-web-design--cms-27498">How To Use CSS Shapes In Your Web Design</a></li>
 <li><a href="https://www.webdesignerdepot.com/2015/03/how-to-get-started-with-css-shapes/">How To Get Started With CSS Shapes</a></li>
 <li><a href="https://medium.com/@MHarreither/what-i-learned-in-one-weekend-with-css-shapes-66ae9be69cc5">What I Learned In One Weekend With CSS Shapes</a></li>
 <li><a href="https://theblog.adobe.com/css-vs-svg-shapes-and-arbitrarily-shaped-ui-components/">CSS vs. SVG: Shapes and Arbitrarily-Shaped UI Components</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Shapes")}}</td>
   <td>{{Spec2("CSS Shapes")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>
